<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta charset="utf-8" />
<meta name="generator" content="Docutils 0.21b.dev: https://docutils.sourceforge.io/" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<meta name="dcterms.date" content="$Date$" />
<title>reStructuredText</title>
<link rel="schema.dcterms" href="http://purl.org/dc/terms/"/>
<link rel="stylesheet" href="docutils/writers/html5_polyglot/minimal.css" type="text/css" />
<link rel="stylesheet" href="docutils/writers/html5_polyglot/responsive.css" type="text/css" />
</head>
<body class="with-toc">
<main id="restructuredtext">
<h1 class="title"><img alt="reStructuredText" src="rst.png" /></h1>
<p class="subtitle" id="markup-syntax-and-parser-component-of-docutils">Markup Syntax and Parser Component of <a class="reference external" href="index.html">Docutils</a></p>
<dl class="docinfo simple">
<dt class="date">Date<span class="colon">:</span></dt>
<dd class="date">$Date$</dd>
</dl>
<aside class="admonition note">
<p class="admonition-title">Note</p>
<p>&quot;reStructuredText&quot; is <strong>ONE</strong> word, <em>not two!</em></p>
</aside>
<nav class="contents" id="contents" role="doc-toc">
<p class="topic-title">Contents</p>
<ul class="simple">
<li><p><a class="reference internal" href="#user-documentation" id="toc-entry-1">User Documentation</a></p></li>
<li><p><a class="reference internal" href="#reference-documentation" id="toc-entry-2">Reference Documentation</a></p></li>
<li><p><a class="reference internal" href="#developer-documentation" id="toc-entry-3">Developer Documentation</a></p>
<ul>
<li><p><a class="reference internal" href="#how-to-s" id="toc-entry-4">How-To's</a></p></li>
</ul>
</li>
<li><p><a class="reference internal" href="#try-it-online" id="toc-entry-5">Try it Online</a></p></li>
<li><p><a class="reference internal" href="#testimonials" id="toc-entry-6">Testimonials</a></p></li>
</ul>
</nav>
<p>reStructuredText is an easy-to-read, what-you-see-is-what-you-get
plaintext markup syntax and parser system.  It is useful for in-line
program documentation (such as Python docstrings), for quickly
creating simple web pages, and for standalone documents.
reStructuredText is designed for extensibility for specific
application domains.  The reStructuredText parser is a component of
<a class="reference external" href="index.html">Docutils</a>.  reStructuredText is a revision and reinterpretation of the
<a class="reference external" href="http://dev.zope.org/Members/jim/StructuredTextWiki/FrontPage/">StructuredText</a> and <a class="reference external" href="mirror/setext.html">Setext</a> lightweight markup systems.</p>
<p>The primary goal of reStructuredText is to define and implement a
markup syntax for use in Python docstrings and other documentation
domains, that is readable and simple, yet powerful enough for
non-trivial use.  The intended purpose of the markup is the conversion
of reStructuredText documents into useful structured data formats.</p>
<p>See <a class="reference external" href="docutils/statemachine.py">statemachine.py</a> for an example of a Python module fully
documented using reStructuredText.</p>
<section id="user-documentation">
<h2><a class="toc-backref" href="#toc-entry-1" role="doc-backlink">User Documentation</a><a class="self-link" title="link to this section" href="#user-documentation"></a></h2>
<ul class="simple">
<li><p><a class="reference external" href="docs/user/rst/quickstart.html">A ReStructuredText Primer</a> (HTML file, or <a class="reference external" href="docs/user/rst/quickstart.txt">text source</a>).</p></li>
<li><p><a class="reference external" href="docs/user/rst/quickref.html">Quick reStructuredText</a> (user reference)</p></li>
<li><p><a class="reference external" href="docs/user/rst/cheatsheet.txt">reStructuredText Cheat Sheet</a> (text only; 1 page for syntax, 1
page directive &amp; role reference)</p></li>
</ul>
<p>Users who have questions or need assistance with Docutils or
reStructuredText should post a message to the <a class="reference external" href="docs/user/mailing-lists.html#docutils-users">Docutils-users</a> mailing
list.</p>
</section>
<section id="reference-documentation">
<h2><a class="toc-backref" href="#toc-entry-2" role="doc-backlink">Reference Documentation</a><a class="self-link" title="link to this section" href="#reference-documentation"></a></h2>
<ul class="simple">
<li><p><a class="reference external" href="docs/ref/rst/introduction.html">An Introduction to reStructuredText</a> (includes the <a class="reference external" href="docs/ref/rst/introduction.html#goals">Goals</a> and
<a class="reference external" href="docs/ref/rst/introduction.html#history">History</a> of reStructuredText)</p></li>
<li><p><a class="reference external" href="docs/ref/rst/restructuredtext.html">reStructuredText Markup Specification</a></p></li>
<li><p><a class="reference external" href="docs/ref/rst/directives.html">reStructuredText Directives</a></p></li>
<li><p><a class="reference external" href="docs/ref/rst/roles.html">reStructuredText Interpreted Text Roles</a></p></li>
</ul>
</section>
<section id="developer-documentation">
<h2><a class="toc-backref" href="#toc-entry-3" role="doc-backlink">Developer Documentation</a><a class="self-link" title="link to this section" href="#developer-documentation"></a></h2>
<ul class="simple">
<li><p><a class="reference external" href="docs/dev/rst/alternatives.html">A Record of reStructuredText Syntax Alternatives</a></p></li>
<li><p><a class="reference external" href="docs/dev/rst/problems.html">Problems With StructuredText</a></p></li>
</ul>
<section id="how-to-s">
<h3><a class="toc-backref" href="#toc-entry-4" role="doc-backlink">How-To's</a><a class="self-link" title="link to this section" href="#how-to-s"></a></h3>
<ul class="simple">
<li><p><a class="reference external" href="docs/howto/rst-directives.html">Creating reStructuredText Directives</a></p></li>
<li><p><a class="reference external" href="docs/howto/rst-roles.html">Creating reStructuredText Interpreted Text Roles</a></p></li>
</ul>
</section>
</section>
<section id="try-it-online">
<h2><a class="toc-backref" href="#toc-entry-5" role="doc-backlink">Try it Online</a><a class="self-link" title="link to this section" href="#try-it-online"></a></h2>
<p>If you want to try reStructuredText out without downloading Docutils, you
can play with the &quot;simple online editor for reStructuredText&quot; on
<a class="reference external" href="http://rst.ninjs.org/">http://rst.ninjs.org/</a></p>
</section>
<section id="testimonials">
<h2><a class="toc-backref" href="#toc-entry-6" role="doc-backlink">Testimonials</a><a class="self-link" title="link to this section" href="#testimonials"></a></h2>
<p>The following testimonials are excerpts from unsolicited posts to
mailing lists and the comp.lang.python newsgroup.  Being excerpts,
there's often context missing, which sometimes tones down the message.</p>
<p><a class="reference external" href="http://mail.python.org/pipermail/doc-sig/2002-March/002526.html">Ueli Schlaepfer on Doc-SIG, 2002-03-28</a>:</p>
<blockquote>
<p>I have adopted reST as my tool of choice for producing notes while
doing lab work (mostly in a matlab environment).  Since then, the
quality of such documentation has increased noticeably, mostly for
two reasons:</p>
<ul class="simple">
<li><p>I no longer need to switch to another tool, so the threshold has
fallen to very low.  Note that &quot;another tool&quot; means Winword...</p></li>
<li><p>Still, I have a powerful set of markup constructs at my
fingertips that let me create the kind of documents I need with
more ease than any other tool I can think of.</p></li>
</ul>
<p>Thanks to reST/DPS [now Docutils --ed], I'll soon be able to go
ahead and apply the same tools for extracting documentation out of
my Python code.  Hey, that's a printable and a browsable version
<em>for free</em>!  Personally, I consider this a large benefit.</p>
<p>... All essential constructs for everyday use are there, and much
more if needed. ...</p>
</blockquote>
<p><a class="reference external" href="http://mail.python.org/pipermail/python-dev/2002-April/022131.html">Guido van Rossum, enthusiastic about PEP 287 but a bit hasty (see the
follow-ups) on Python-Dev, 2002-04-02</a>:</p>
<blockquote>
<p>Good PEP, David!  What's the next step?  Should the processing
code be incorporated in the standard library?  Should we start
converting the standard library docs to reStructuredText?</p>
</blockquote>
<p><a class="reference external" href="http://mail.python.org/pipermail/python-list/2002-April/096013.html">Timothy Delaney on comp.lang.python, 2002-04-03</a>:</p>
<blockquote>
<p>I read through all the reStructuredText docs, comparing the text
versions to the html versions.  I found the text versions to be
<em>very</em> easy to read, whilst making it obvious in most cases when
something was &quot;special&quot;.</p>
<p>I particularly like the system of doing hyperlinks...</p>
<p>Definitely +1 from me ... I would really like a standard, clean
docstring format.  Might make it easier to get my next project
done in Python...</p>
</blockquote>
<p><a class="reference external" href="http://mail.python.org/pipermail/python-dev/2002-April/022212.html">Guido van Rossum on Python-Dev, 2002-04-03</a>:</p>
<blockquote>
<p>I think that reStructuredText is a good format for marking up
docstrings; it's probably as good as it gets given the
requirements (a fairly elaborate feature set, yet more readable
&quot;in the raw&quot; than HTML).</p>
</blockquote>
<p><a class="reference external" href="http://mail.python.org/pipermail/python-list/2002-April/096117.html">Richard Jones on comp.lang.python, 2002-04-03</a>:</p>
<blockquote>
<p>How I see it is that ReST is a middle ground between markup and
non-.  It has markup, and you can use it to the extreme.  Or you
can follow some simple conventions (the most basic form of markup)
and not worry about all the finer detail stuff. The difference
between:</p>
<pre class="literal-block">&#64;section{The Section Title}</pre>
<p>and:</p>
<pre class="literal-block">The Section Title
-----------------</pre>
<p>Is pretty clearly to me that the second doesn't <em>look</em> like
markup, even though it is.</p>
</blockquote>
<p><a class="reference external" href="http://mail.python.org/pipermail/python-dev/2002-April/022247.html">Guido van Rossum on Python-Dev, 2002-04-04</a>:</p>
<blockquote>
<p>Structured text is really a great idea for certain situations;
reST is a much better implementation of the idea than any versions
I've seen before.</p>
</blockquote>
<p><a class="reference external" href="http://mail.python.org/pipermail/python-list/2002-April/096656.html">Max M on comp.lang.python, 2002-04-05</a>:</p>
<blockquote>
<p>Any programmer can learn the basics in 15 minutes or less.</p>
<p>And it really is very very easy to write documents in it.  I do
believe that if I were ever to write a book (again) I would write
it in ReST.</p>
<p>And as far as I can tell from the specs, ReST solves most of the
problems I have had with structured text.  A few things gets a
little more complicated and some get simpler.  All in all a good
bargain.</p>
<p>I would certainly use it.  I also hope that it gets integrated
into Zope.</p>
</blockquote>
<p><a class="reference external" href="http://mail.python.org/pipermail/python-dev/2002-April/022443.html">David Abrahams on Python-Dev, 2002-04-06</a>:</p>
<blockquote>
<p>Incidentally, I'm really excited about reST.  I've been looking
for a tolerable markup for C++ comments, and reST looks like it
might fit the bill.</p>
</blockquote>
<p><a class="reference external" href="http://mail.python.org/pipermail/python-dev/2002-August/027198.html">Eric Jones on Python-Dev, 2002-08-01</a>:</p>
<blockquote>
<p>I would very much like to see reStructuredText, or some minor
variation on it, move forward as a &quot;standard&quot; for doc-strings very
soon.  I have long lamented not having a prescribed format <em>and</em>
an associated processing tool suite included in the standard
library.  Even if the format isn't perfect (I think it looks very
good), it is time to pick a reasonable candidate and go.</p>
</blockquote>
<p>This being the Internet, there were plenty of people opposed to the
idea of reStructuredText, some vehemently.  Discovering <em>those</em> gems
is left as an exercise for the reader.</p>
<!-- Local Variables:
mode: indented-text
indent-tabs-mode: nil
sentence-end-double-space: t
fill-column: 70
End: -->
</section>
</main>
<footer>
<p><a class="reference external" href="rst.txt">View document source</a>.
Generated on: 2023-09-13 17:06 UTC.
Generated by <a class="reference external" href="https://docutils.sourceforge.io/">Docutils</a> from <a class="reference external" href="https://docutils.sourceforge.io/rst.html">reStructuredText</a> source.
</p>
</footer>
</body>
</html>
